﻿using System;
using System.Reflection;
using CommunityToolkit.Mvvm.ComponentModel;

namespace NetDocsForLLM.Models
{
    public class AssemblyModel : ObservableObject
    {
        private string _filePath;
        private string _name;
        private Version _version;
        private bool _hasXmlDocumentation;

        public string FilePath
        {
            get => _filePath;
            set => SetProperty(ref _filePath, value);
        }

        public string Name
        {
            get => _name;
            set => SetProperty(ref _name, value);
        }

        public Version Version
        {
            get => _version;
            set => SetProperty(ref _version, value);
        }

        public bool HasXmlDocumentation
        {
            get => _hasXmlDocumentation;
            set => SetProperty(ref _hasXmlDocumentation, value);
        }

        public Assembly? LoadedAssembly { get; set; }

        public string XmlDocPath { get; set; }

        public AssemblyModel(string filePath)
        {
            _filePath = filePath;
            _name = System.IO.Path.GetFileName(filePath);
            _version = new Version(1, 0);
            _hasXmlDocumentation = false;
            XmlDocPath = string.Empty;
        }
    }
}